=== other/docker/esp32/bootstrap/CMakeLists.txt ===
idf_component_register(
  SRCS hello_main.cc
  INCLUDE_DIRS "."
  REQUIRES esp_netif lwip)
