=== debian/changelog ===
libtoxcore (0.2.19-1build1) plucky; urgency=medium

  * No-change rebuild for libconfig11.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Mon, 27 Jan 2025 19:45:09 +0000

libtoxcore (0.2.19-1) unstable; urgency=medium

  * New upstream release
  * Remove flaky autopkgtest (Closes: #1053501)
  * Bump Standards-Version to 4.7.0

 -- Yangfl <mmyangfl@gmail.com>  Sun, 30 Jun 2024 23:52:53 +0800
