=== debian/watch ===
version=4
opts="downloadurlmangle=s%archive/refs/tags/v?(\d[\d.]*)\.tar\.gz%releases/download/v$1/c-toxcore-$1.tar.gz%,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%libtoxcore-$1.tar.gz%,pgpsigurlmangle=s%$%.asc%" \
   https://github.com/TokTok/c-toxcore/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
