## libtoxcore 0.2.20

=== CMakeLists.txt ===
--- 
+++ 
@@ -44,7 +44,7 @@
 # versions in a synchronised way.
 set(PROJECT_VERSION_MAJOR "0")
 set(PROJECT_VERSION_MINOR "2")
-set(PROJECT_VERSION_PATCH "19")
+set(PROJECT_VERSION_PATCH "20")
 set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
 
 # set .so library version / following libtool scheme
@@ -161,7 +161,7 @@
 option(BOOTSTRAP_DAEMON "Enable building of tox-bootstrapd" ON)
 if(BOOTSTRAP_DAEMON AND WIN32)
   message(WARNING "Building tox-bootstrapd for Windows is not supported, disabling")
-  set(BOOTSTRAP_DAEMON OFF)
+  set(BOOTSTRAP_DAEMON OFF CACHE BOOL "" FORCE)
 endif()
 
 option(BUILD_FUZZ_TESTS "Build fuzzing harnesses" OFF)
@@ -177,6 +177,7 @@
 
 if(MUST_BUILD_TOXAV)
   set(NO_TOXAV_ERROR_TYPE SEND_ERROR)
+  set(BUILD_TOXAV ON CACHE BOOL "" FORCE)
 else()
   set(NO_TOXAV_ERROR_TYPE WARNING)
 endif()
@@ -184,11 +185,11 @@
 if(BUILD_TOXAV)
   if(NOT OPUS_FOUND)
     message(${NO_TOXAV_ERROR_TYPE} "Option BUILD_TOXAV is enabled but required library OPUS was not found.")
-    set(BUILD_TOXAV OFF)
+    set(BUILD_TOXAV OFF CACHE BOOL "" FORCE)
   endif()
   if(NOT VPX_FOUND)
     message(${NO_TOXAV_ERROR_TYPE} "Option BUILD_TOXAV is enabled but required library VPX was not found.")
-    set(BUILD_TOXAV OFF)
+    set(BUILD_TOXAV OFF CACHE BOOL "" FORCE)
   endif()
 endif()
 
@@ -338,8 +339,3 @@
   toxcore/tox.c
   toxcore/tox_dispatch.c
   toxcore/tox_dispatch.h
-  toxcore/tox_event.c
-  toxcore/tox_event.h
-  toxcore/tox_events.c
-  toxcore/tox_events.h
-  toxcore/tox.h
