=== third_party/cmp/CMakeLists.txt ===
# Edit following two lines to set component requirements (see docs)
set(COMPONENT_SRCS "cmp.c" )
set(COMPONENT_ADD_INCLUDEDIRS ".")
register_component()
