=== debian/changelog ===
libtoxcore (0.2.20-1build1) resolute; urgency=medium

  * Rebuild against latest libvpx

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sun, 02 Nov 2025 11:16:56 -0500

libtoxcore (0.2.20-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.7.2

 -- Yangfl <mmyangfl@gmail.com>  Fri, 28 Mar 2025 11:37:55 +0800
