=== debian/control ===
--- 
+++ 
@@ -6,12 +6,12 @@
  cmake,
  pkgconf,
  libconfig-dev,
- libncurses5-dev,
+ libncurses-dev,
  libopus-dev,
  libsodium-dev,
  libvpx-dev,
 Rules-Requires-Root: no
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Section: libs
 Homepage: https://tox.chat
 Vcs-Git: https://salsa.debian.org/yangfl-guest/c-toxcore.git
